Cecilia API Documentation — Cecilia 5.4.1 documentation

# Cecilia API Documentation

## What is a Cecilia module

A Cecilia module is a python file (with the extension ‘C5’, associated to the application) containing a class named Module, within which the audio processing chain is developed, and a list called Interface, telling the software what are the graphical controls necessary for the proper operation of the module. the file can then be loaded by the application to apply the process on different audio signals, whether coming from sound files or from the microphone input. Processes used to manipulate the audio signal must be written with the Python’s dedicated signal processing module ‘pyo’.

## API Documentation Structure

This API is divided into two parts: firstly, there is the description of the parent class, named BaseModule, from which every module must inherit. This class implements a lot of features that ease the creation of a dsp chain. Then, the various available GUI elements (widgets) are presented.

- BaseModule API
  - Declaration of the module’s class
  - Module’s output
  - Module’s documentation
  - Public Attributes
  - Public Methods
  - Template
- Interface API
  - cfilein : creates a popup menu to load a soundfile in a table
  - csampler : creates a popup menu to load a soundfile in a sampler
  - cpoly : creates two popup menus used as polyphony manager
  - cgraph : creates a graph only automated parameter or a shapeable envelope
  - cslider : creates a slider, and its own graph line, for time-varying controls
  - crange : two-sided slider, with its own graph lines, for time-varying controls
  - csplitter : creates a multi-knobs slider used to split the spectrum in sub-regions
  - ctoggle : creates a two-states button
  - cpopup : creates a popup menu offering a limited set of choices
  - cbutton : creates a button that can be used as an event trigger
  - cgen : creates a list entry useful to generate list of arbitrary values
  - Colours
  - Example 1
  - Example 2